/**
 * The Core of GitHub for Dart.
 * 
 * Contains the Models and other GitHub stuff.
 */
library github.common;

import 'dart:async';
import 'dart:convert' show JSON, UTF8;
import 'package:crypto/crypto.dart' show CryptoUtils;

import "package:html5lib/parser.dart" as htmlParser;
import "package:html5lib/dom.dart" as html;

import "package:quiver/async.dart" show FutureGroup;

import "package:xml/xml.dart" as xml;

import 'http.dart' as http;

import 'src/common/util.dart';

part 'src/common/auth.dart';
part 'src/common/repo.dart';
part 'src/common/user.dart';
part 'src/common/json.dart';
part 'src/common/github.dart';
part 'src/common/stats.dart';
part 'src/common/organization.dart';
part 'src/common/api.dart';
part 'src/common/issues.dart';
part 'src/common/misc.dart';
part 'src/common/commits.dart';
part 'src/common/pages.dart';
part 'src/common/hooks.dart';
part 'src/common/oauth2.dart';
part 'src/common/pull_request.dart';
part 'src/common/contents.dart';
part 'src/common/releases.dart';
part 'src/common/errors.dart';
part 'src/common/gists.dart';
part 'src/common/notifications.dart';
part 'src/common/watchers.dart';
part 'src/common/explore.dart';
part 'src/common/pagination.dart';
part 'src/common/search.dart';
part 'src/common/events.dart';
part 'src/common/keys.dart';
part 'src/common/blog.dart';
part 'src/common/authorizations.dart';
part 'src/common/git.dart';
part 'src/common/git_blob.dart';
part 'src/common/git_commit.dart';
part 'src/common/git_tree.dart';
part 'src/common/octodex.dart';
part 'src/common/shortener.dart';